#include "ImageImportTga.h"
#include "ltga.h"

#ifdef __BCPLUSPLUS__

#else
	#define try 		{
	#define __finally 	}
	#define catch(x) 	}
#endif

bool ImportTgaFile ( 	mstring fname, 
			    	TTexture * image, 
				bool allocateimage, 
				bool allocatetexture,
				bool append )
{
        LTGA * tga = new LTGA();
        if (!tga) return false;
        try
        {
                if (tga->LoadFromFile((char*)fname.c_str()))
                {
                        int numofbyts;
                        if (tga->GetImageType()==itRGBA)
                                numofbyts = 4;
                                else
                                numofbyts = 3;

                        if (append && (image->GetWidth()!=tga->GetImageWidth() ||
                        		image->GetHeight()!=tga->GetImageHeight() ||
                                        image->GetNumOfBytes()!=numofbyts))
                        {
                                delete tga;
                                tga = NULL;
                                return false;
                        }

                        if ( tga->GetImageType()!=itRGB &&
                             tga->GetImageType()!=itRGBA )
                        {
                                delete tga;
                                tga = NULL;
                                return false;
                        }

                        TTextureFrame * tex    = image->AddFrame();

	                image->SetInfo ( tga->GetImageWidth(), tga->GetImageHeight(), numofbyts );
        	        image->SetAnimationRange ( 0, image->GetNumOfFrames()-1 );
                	image->SetCurrentFrameNo ( 0 );

                        GLuint texture = -1;

                        if (allocatetexture)
                        {
                                glGenTextures     ( 1, &texture );
                                if ( texture != -1 )
                                {
                                        tex->SetInfo      ( NULL, texture );

                                        glBindTexture     ( GL_TEXTURE_2D, texture );

                                        if (tga->GetImageType()==itRGBA)
                                                gluBuild2DMipmaps ( GL_TEXTURE_2D, numofbyts,
                                                            image->GetWidth(), image->GetHeight(),
                                                            GL_RGBA, GL_UNSIGNED_BYTE, tga->GetPixels() );
                                        else
                                        if (tga->GetImageType()==itRGB)
                                                gluBuild2DMipmaps ( GL_TEXTURE_2D, numofbyts,
                                                            image->GetWidth(), image->GetHeight(),
                                                            GL_RGB, GL_UNSIGNED_BYTE, tga->GetPixels() );
                                }
                        }

                        if (allocateimage)
                        {
                                int size   = image->GetWidth()*image->GetHeight()*numofbyts;
                                unsigned char * texbuffer = (unsigned char*)malloc(size);
                                if (texbuffer)
                                        mCopyMemory( texbuffer, tga->GetPixels(), size );

                                tex->SetInfo ( texbuffer, texture );
                        }
                }
                else
                {
                        delete tga;
                        tga = NULL;
                        return false;
                }
        }
        __finally
        {
                if (tga) delete tga;
        }
        return true;
}