//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <dstring.h>

#include "MuhGLPanel.h"
#include "extgl.h"

#pragma package(smart_init)

static HGLRC hrc = NULL;
                            
//---------------------------------------------------------------------------

static inline void ValidCtrCheck(TMuhGLPanel *)
{
         new TMuhGLPanel(NULL);
}

//---------------------------------------------------------------------------

namespace Muhglpanel                             
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TMuhGLPanel)};
                 RegisterComponents("cOpenGL", classes, 0);
        }
}

//---------------------------------------------------------------------------
void __fastcall TMuhGLPanel::SetPixelFormatDescriptor(unsigned char alpha)
{
    PIXELFORMATDESCRIPTOR pfd
    = {
    	sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA,
        24,
        0,0,0,0,0,0,
        0,0,
        0,
        0,0,0,0,
        32,
        0,
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,
    };

    pfd.nSize           = sizeof(PIXELFORMATDESCRIPTOR);
    pfd.nVersion        = 1;
    pfd.dwFlags         = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
    pfd.iPixelType      = PFD_TYPE_RGBA;
    pfd.cColorBits      = fPixelFormat->NumOfColorBits;

    pfd.cAlphaBits      = alpha;

    pfd.cAccumBits      = fPixelFormat->NumOfAccumulationBits;
    pfd.cDepthBits      = fPixelFormat->NumOfDepthBits;
    pfd.cStencilBits    = fPixelFormat->NumOfStencilBits;
    pfd.iLayerType      = PFD_MAIN_PLANE;

    static int PixelFormat[256];

    if (false)                          // wglChoosePixelFormatARB
    {
        const int aiParamArray[]=
          {
           WGL_DRAW_TO_WINDOW_ARB, true,
           WGL_SUPPORT_OPENGL_ARB, true,
           WGL_DOUBLE_BUFFER_ARB, true,
           WGL_PIXEL_TYPE_ARB, WGL_TYPE_RGBA_ARB,
           WGL_ALPHA_BITS_ARB, 8,
           WGL_COLOR_BITS_ARB, 24,
           WGL_DEPTH_BITS_ARB, 24,
           WGL_STENCIL_BITS_ARB, 8,
           0x2042, 3,    // --->  2: 2x AA,    3: 3x AA (GeForce3lerde quincunx AA),  4: 4x AA
           0,0
          };

          const float afParamArray[] = {0,0};
          static int aiFormats[256];
          UINT nNumFormats;
          bool bRes = wglChoosePixelFormatARB(hdc, aiParamArray, afParamArray, 255 /*nMaxFormats*/,
                                              PixelFormat , &nNumFormats);
          if (!(bRes && nNumFormats>=1))
          {
                        LPVOID lpMsgBuf;
                        FormatMessage(
                            FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                            NULL,
                            GetLastError(),
                            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                            (LPTSTR) &lpMsgBuf,
                            0,
                            NULL
                        );
                        ShowMessage(AnsiString((char*)lpMsgBuf)+"(wglChoosePixelFormatARB)");
                        LocalFree( lpMsgBuf );
                        return;
          }
    }
    else
    {
            if ( (PixelFormat[0] = ChoosePixelFormat(hdc, &pfd)) == 0 )
                {
                        LPVOID lpMsgBuf;
                        FormatMessage(
                            FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                            NULL,
                            GetLastError(),
                            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                            (LPTSTR) &lpMsgBuf,
                            0,
                            NULL
                        );
                        ShowMessage(AnsiString((char*)lpMsgBuf)+"(ChoosePixelFormat)");
                        LocalFree( lpMsgBuf );
                        return;
                }
    }

    if (SetPixelFormat(hdc, PixelFormat[0], &pfd) == FALSE)
    {
        LPVOID lpMsgBuf;
        FormatMessage(
                FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                NULL,
                GetLastError(),
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                (LPTSTR) &lpMsgBuf,
                0,
                NULL
                );
        ShowMessage(AnsiString((char*)lpMsgBuf)+"(SetPixelFormat)");
        LocalFree( lpMsgBuf );
        return;
    }
}

//---------------------------------------------------------------------------

__fastcall TMuhGLPanel::TMuhGLPanel(TComponent* Owner) : TCustomPanel(Owner),
        fOnInitialize	(NULL),
        fOnFirstDraw	(NULL),
        fOnPanelResize	(NULL),
        fOnDisplay	(NULL),
        fOnFinalize	(NULL)
{
    fInitialized                = false;
    fFirstDraw                  = true;
    fFrameRate                  = 1;

    dx = 1;
    dy = 1;
    dz = 1;
    _control87(MCW_EM, MCW_EM);

    fPixelFormat        = new TMuhGLPixelFormat();
    fGLProperties       = new TMuhGLProperties();

    if(ComponentState.Contains(csDesigning)) return;

    BevelOuter 		= bvNone;
    OnResize   		= MyOnResize;
}

//---------------------------------------------------------------------------

__fastcall TMuhGLPanel::~TMuhGLPanel()
{
	FinalizeGL();
   	delete fPixelFormat;
   	delete fGLProperties;
}

//---------------------------------------------------------------------------

void __fastcall TMuhGLPanel::InitializeGL()
{
    	if(ComponentState.Contains(csDesigning)) return;

        hdc = GetDC(Handle);
        SetPixelFormatDescriptor(0);
        if (!hrc) hrc = wglCreateContext(hdc);
        if(hrc == NULL)
        {
                LPVOID lpMsgBuf;
                FormatMessage(
                    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                    NULL,
                    GetLastError(),
                    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                    (LPTSTR) &lpMsgBuf,
                    0,
                    NULL
                );

                // Free the buffer.
                LocalFree( lpMsgBuf );
                return;
        }

        // Initialize OpenGL extensions
        wglMakeCurrent(hdc, hrc);

        _wglSetDC(hdc);
        glInitialize();

        wglMakeCurrent(hdc, NULL);

        fInitialized = true;

        if (fOnInitialize) fOnInitialize(this);
}

void __fastcall TMuhGLPanel::FinalizeGL()
{
    	if(ComponentState.Contains(csDesigning)) return;

        fInitialized = false;
        if (fOnFinalize) fOnFinalize(this);

        UnMakeCurrent   ();

        wglDeleteContext(hrc);
        hrc = NULL;
        DeleteDC        (hdc);
}

void __fastcall TMuhGLPanel::MyOnResize(System::TObject* Sender)
{
    if(ComponentState.Contains(csDesigning)) return;

    int w = Width;
    int h = Height;
    if(w == 0) w = 1;
    if(h == 0) h = 1;
    fAspectRatio = (GLfloat)w/(GLfloat)h;

    if (!fInitialized)
        InitializeGL();
        else
    if (fOnPanelResize) fOnPanelResize(Sender);
}

//---------------------------------------------------------------------------

void __fastcall TMuhGLPanel::MakeCurrent()
{
    	static void * CurrentHdc = NULL;
	if (CurrentHdc != hdc)
	{
        	if(wglMakeCurrent(hdc, hrc) == false) ShowMessage("Could not MakeCurrent");
        	CurrentHdc = hdc;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMuhGLPanel::UnMakeCurrent()
{
        wglMakeCurrent(hdc, NULL);
}

//---------------------------------------------------------------------------

void __fastcall TMuhGLPanel::PostRendering  ( )
{
	if (!fInitialized) return;

        // Do Final Operation
        if (fGLProperties->FinalOperation==foGLFinish) glFinish();
                else
        if (fGLProperties->FinalOperation==foGLFlush) glFlush();

        if (fGLProperties->DoSwapBuffers) SwapBuffers(hdc);

        Canvas->Unlock( );
}

void __fastcall TMuhGLPanel::PreRendering  ( int vleft, int vright, int vwidth, int vheight )
{
	if (!fInitialized) return;

        Canvas->Lock( );
        MakeCurrent ( );

        // Setup Viewport
        if ( vwidth == 0 && vheight == 0 )
	        glViewport(0, 0, this->Width, this->Height);
                else
	        glViewport( vleft, vright, vwidth, vheight );

        // Clear Buffers
        glClearColor( (fGLProperties->ClearColor & 0xff)/255.0,
                     ((fGLProperties->ClearColor>>8) & 0xff)/255.0 ,
                     ((fGLProperties->ClearColor>>16) & 0xff)/255.0, 1.0 );

        if (fGLProperties->ClearColorBuffer && fGLProperties->ClearDepthBuffer)
                glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
                else
        if (fGLProperties->ClearColorBuffer)
                glClear(GL_COLOR_BUFFER_BIT);
                else
        if (fGLProperties->ClearDepthBuffer)
                glClear(GL_DEPTH_BUFFER_BIT);
}

void __fastcall TMuhGLPanel::RenderFrame ( )
{
	if (!fInitialized) return;

        if (fFirstDraw)
        {
        	if (fOnFirstDraw) fOnFirstDraw(this);
                fFirstDraw = false;
                TickCount  = GetTickCount()-1;
        }

        long tcount	= GetTickCount();
        long frametime  = tcount - TickCount;
        TickCount 	= tcount;

        if ( frametime == 0 ) frametime = 1;

        fFrameRate = 1000.0/frametime;

        // Make current & clear background
	PreRendering  ( );

        // Call Event
        if (fOnDisplay) fOnDisplay(this);

        // finish & swap buffers
	PostRendering  ( );
}

//---------------------------------------------------------------------------


