#ifndef __GAME_ENVIRONMENT_PLUGINS__
#define __GAME_ENVIRONMENT_PLUGINS__

//******************************************************************************
// INCLUDES
//******************************************************************************

#include "standard_objects.h"

//******************************************************************************
// Classes
//******************************************************************************

class TGameFileMeshObject;
class TGameTerrainObject;
class TGameRiverObject;

//******************************************************************************
// TGameFileMeshObject
//******************************************************************************

class TGameFileMeshObject : public TGameMeshObject
{
protected:
        mstring                                 meshFile;
        bool                                    animationOn;
        bool					useAllAnimationFrames;
        unsigned int     			animationStartFrame;
        unsigned int     			animationEndFrame;
        unsigned int     			animationFrameDuration;
        unsigned int     			currentFrameTime;
        bool					loopAnimation;

        virtual void DeallocateMesh          ( );
        virtual void GenerateMesh            ( );
        virtual void GenerateBoundingVolumes ( );
public:
                 TGameFileMeshObject ( TGameObjectLayer * player );
        virtual ~TGameFileMeshObject ( );

        // mesh
        virtual void    SetUniqueMesh                   ( bool unique );

        // simulation time notification
        virtual void    AdvanceTime                     ( unsigned int deltatime ); // in miliseconds

        // save and load
	virtual bool 		LoadFromStream 	   ( TGameIOStream * stream );
	virtual bool 		SaveToStream   	   ( TGameIOStream * stream );

        // additional methods
        virtual mstring         GetMeshFile                     ( );
        virtual void            SetMeshFile                     ( mstring mfile );

        virtual bool            GetAnimationOn                  ( );
        virtual void            SetAnimationOn                  ( bool animon );

        virtual bool		GetUseAllAnimationFrames        ( );
        virtual void            SetUseAllAnimationFrames        ( bool useallf );

        virtual unsigned int	GetAnimationStartFrame          ( );
        virtual void            SetAnimationStartFrame          ( unsigned int frm );

        virtual unsigned int	GetAnimationEndFrame            ( );
        virtual void            SetAnimationEndFrame            ( unsigned int frm );

        virtual unsigned int	GetAnimationFrameDuration       ( );
        virtual void            SetAnimationFrameDuration       ( unsigned int fduration );	// in miliseconds

        virtual bool		GetLoopAnimation                ( );
        virtual void            SetLoopAnimation                ( bool loopa );
};


//******************************************************************************
// TGameTerrainObject
//******************************************************************************

class TGameTerrainObject : public TGameFileMeshObject
{
protected:
public:
                 TGameTerrainObject ( TGameObjectLayer * player );
        virtual ~TGameTerrainObject ( );
};

//******************************************************************************
// TGameRiverObject
//******************************************************************************

class TGameRiverObject : public TGameFileMeshObject
{
protected:
public:
                 TGameRiverObject ( TGameObjectLayer * player );
        virtual ~TGameRiverObject ( );
};


#endif
