//---------------------------------------------------------------------------

#include "plugin_controller.h"

//******************************************************************************
// Extern Objects
//******************************************************************************

TGameObjectPluginContainer ObjectPlugins;

//******************************************************************************
// TGameObjectPlugin
//******************************************************************************

TGameObjectPlugin::TGameObjectPlugin ( )
{
        category        = "";
        name            = "";
        createObject    = NULL;
}

TGameObjectPlugin::~TGameObjectPlugin      ( )
{
}

mstring TGameObjectPlugin::GetCategory     ( )
{
        return category;
}

mstring TGameObjectPlugin::GetName         ( )
{
        return name;
}

void * TGameObjectPlugin::CreateObject ( void * player )
{
        if ( createObject )
                return createObject( player );
                else
                return NULL;
}

//******************************************************************************
// TGameObjectPluginContainer
//******************************************************************************

void TGameObjectPluginContainer::RegisterPlugin ( mstring category, mstring name, TOnCreateMhtmObject createcallback )
{
        TGameObjectPlugin * plg  = new TGameObjectPlugin();
        plg->category            = category;
        plg->name                = name;
        plg->createObject        = createcallback;
        plugins.push_back( plg );
}

TGameObjectPluginContainer::TGameObjectPluginContainer   ( )
{
}

TGameObjectPluginContainer::~TGameObjectPluginContainer  ( )
{
        for ( int i = 0; i<plugins.size(); i++ )
                delete plugins[i];
        plugins.clear();
}

int TGameObjectPluginContainer::GetNumOfPlugins ( )
{
        return plugins.size();
}

TGameObjectPlugin * TGameObjectPluginContainer::GetPlugin ( int index )
{
        if ( index<0 || index>=plugins.size() ) return NULL;
        return plugins[index];
}

TGameObjectPlugin * TGameObjectPluginContainer::FindPlugin ( mstring category, mstring name )
{
        for ( int i = 0; i<plugins.size(); i++ )
                if ( plugins[i]->category == category &&
                     plugins[i]->name == name )
                        return plugins[i];
        return NULL;
}

void TGameObjectPluginContainer::GetPlugins ( mstring category,
                                              std::vector<TGameObjectPlugin*> & plgs )
{
        plgs.clear();
        for ( int i = 0; i<plugins.size(); i++ )
                if ( plugins[i]->category == category )
                        plgs.push_back ( plugins[i] );
}

