#ifndef __GAME_ENVIRONMENT_OBJECT_PLUGINS__
#define __GAME_ENVIRONMENT_OBJECT_PLUGINS__

//******************************************************************************
// INCLUDES
//******************************************************************************

#include "main_functions.h"

#include <vector>

//******************************************************************************
// Classes
//******************************************************************************

class TGameObjectPlugin;
class TGameObjectPluginContainer;

//******************************************************************************
// Extern Objects
//******************************************************************************

extern TGameObjectPluginContainer ObjectPlugins;

//******************************************************************************
// Plugin Object Management Function Definitions
//******************************************************************************

typedef void * ( __stdcall *TOnCreateMhtmObject) ( void * player );

//******************************************************************************
// TGameObjectPlugin
//******************************************************************************

class TGameObjectPlugin
{
        friend TGameObjectPluginContainer;
protected:
        mstring                 category;
        mstring                 name;
        TOnCreateMhtmObject     createObject;
public:
		TGameObjectPlugin       ( );
        virtual ~TGameObjectPlugin      ( );

        mstring         GetCategory     ( );
        mstring         GetName         ( );
        void *          CreateObject    ( void * player );
};

//******************************************************************************
// TGameObjectPluginContainer
//******************************************************************************

class TGameObjectPluginContainer
{
protected:
        std::vector<TGameObjectPlugin*> plugins;
public:
	TGameObjectPluginContainer   ( );
        ~TGameObjectPluginContainer  ( );

        int                     GetNumOfPlugins ( );
        TGameObjectPlugin *     GetPlugin       ( int index );
        TGameObjectPlugin *     FindPlugin      ( mstring category, mstring name );
        void                    GetPlugins      ( mstring category, std::vector<TGameObjectPlugin*> & plgs );
        void                    RegisterPlugin  ( mstring category, mstring name, TOnCreateMhtmObject createcallback );        
};

#endif
